### 2.16 File caching

The file caching mechanism is embedded within BFD and allows the application to open as many BFDs as it wants without regard to the underlying operating system's file descriptor limit (often as low as 20 open files). The module in `cache.c` maintains a least recently used list of `BFD_CACHE_MAX_OPEN` files, and exports the name `bfd_cache_lookup`, which runs around and makes sure that the required BFD is open. If not, then it chooses a file to close, closes it and opens the one wanted, returning its file handle.

#### 2.16.1 Caching functions

##### 2.16.1.1 `bfd_cache_init`

Synopsis

         bfd_boolean bfd_cache_init (bfd *abfd);

Description
Add a newly opened BFD to the cache.

##### 2.16.1.2 `bfd_cache_close`

Synopsis

         bfd_boolean bfd_cache_close (bfd *abfd);

Description
Remove the BFD abfd from the cache. If the attached file is open, then close it too.

Returns
`FALSE` is returned if closing the file fails, `TRUE` is returned if all is well.

##### 2.16.1.3 `bfd_cache_close_all`

Synopsis

         bfd_boolean bfd_cache_close_all (void);

Description
Remove all BFDs from the cache. If the attached file is open, then close it too.

Returns
`FALSE` is returned if closing one of the file fails, `TRUE` is returned if all is well.

##### 2.16.1.4 `bfd_open_file`

Synopsis

         FILE* bfd_open_file (bfd *abfd);

Description
Call the OS to open a file for abfd. Return the `FILE *` (possibly `NULL`) that results from this operation. Set up the BFD so that future accesses know the file is open. If the `FILE *` returned is `NULL`, then it won't have been put in the cache, so it won't have to be removed from it.